Index: /trunk/src/lib/collision_reaction/collision_tube.cc
===================================================================
--- /trunk/src/lib/collision_reaction/collision_tube.cc	(revision 10013)
+++ /trunk/src/lib/collision_reaction/collision_tube.cc	(revision 10013)
@@ -0,0 +1,140 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_REACTION
+
+#include "collision_tube.h"
+
+#include "world_entity.h"
+
+#include "collision.h"
+#include "collision_event.h"
+#include "collision_reaction.h"
+
+#include "cr_object_damage.h"
+#include "cr_physics_ground_walk.h"
+#include "cr_physics_full_walk.h"
+
+#include "debug.h"
+
+
+namespace CoRe
+{
+
+  ObjectListDefinition(CollisionTube);
+
+  CollisionTube* CollisionTube::singletonRef = NULL;
+
+
+  /**
+   * standard constructor
+   * @todo this constructor is not jet implemented - do it
+   */
+  CollisionTube::CollisionTube ()
+  {
+    this->registerObject(this, CollisionTube::_objectList);
+  }
+
+
+  /**
+   * standard deconstructor
+   */
+  CollisionTube::~CollisionTube ()
+  {
+    this->reset();
+  }
+
+
+
+  /**
+   * resets the collision tube after each collision detection cycle
+   */
+  void CollisionTube::reset()
+  {
+    this->_collisionList.clear();
+  }
+
+
+  /**
+   * gets the collision object useable for collision events registarations
+   * @param entityA collision partner 1
+   * @param entityB collision partner 2
+   * @return the collision object to be used
+   */
+  Collision* CollisionTube::registerCollision(WorldEntity* entityA, WorldEntity* entityB)
+  {
+    assert( entityA != NULL && entityB != NULL);
+
+    Collision* collision = NULL;
+    if( !this->_collisionList.empty())
+      collision = this->_collisionList.back();
+
+    // check if there is already a collision defined between these objects or this is the first collision at all
+    if( collision == NULL || !collision->same(*entityA, *entityB))
+    {
+      collision = CREngine::getInstance()->popCollisionObject();
+      collision->collide( entityA, entityB);
+      this->_collisionList.push_back(collision);
+    }
+
+    return collision;
+  }
+
+
+  /**
+   * registers a new CollisionEvent
+   * @param entityA one collision object
+   * @param entityB the other collision objectName
+   * @param bvA bounding volume of object A
+   * @param bvB bounding volume of object B
+   *
+   * this function doesn't check if the entities in question actualy are registered for any collisions
+   */
+  void CollisionTube::registerCollisionEvent(WorldEntity* entityA, WorldEntity* entityB, BoundingVolume* bvA, BoundingVolume* bvB)
+  {
+    // first get a useable collision object
+    Collision* collision = this->registerCollision(entityA, entityB);
+
+    // now register the new collision event
+    CollisionEvent* collisionEvent = CREngine::getInstance()->popCollisionEventObject();
+    collisionEvent->collide( CREngine::CR_COLLISION_TYPE_OBB, entityA, entityB, bvA, bvB);
+    collision->registerCollisionEvent( collisionEvent);
+  }
+
+
+  /**
+   * registers a new CollisionEvent, only used by ground to object collision (eg. bsp model)
+   * @param type type of collision as stated in cr_def.h
+   * @param entity the WorldEntity colliding with the ground
+   * @param groundEntity the WorldEntity representing the ground
+   * @param normal the normal vector for the ground (up) - not always specified
+   * @param position the position of the collision relative to the object center
+   * @param bInWall true if the entity is in the ground material
+   */
+  void CollisionTube::registerCollisionEvent(CREngine::CollisionType type, WorldEntity* entity, WorldEntity* groundEntity,
+      const Vector& normal, const Vector& position, bool bInWall)
+  {
+    // first get a useable collision object
+    Collision* collision = this->registerCollision(entity, groundEntity);
+
+    // now register the new collision event
+    CollisionEvent* collisionEvent = CREngine::getInstance()->popCollisionEventObject();
+    collisionEvent->collide( type, entity, groundEntity, normal, position, bInWall);
+    collision->registerCollisionEvent( collisionEvent);
+  }
+
+
+
+}// namespace end
+
Index: /trunk/src/lib/collision_reaction/collision_tube.h
===================================================================
--- /trunk/src/lib/collision_reaction/collision_tube.h	(revision 10013)
+++ /trunk/src/lib/collision_reaction/collision_tube.h	(revision 10013)
@@ -0,0 +1,96 @@
+/*!
+ * @file collision_tube.h
+ *
+ * collision tube collects all collisions from all entities
+ *
+ *  The collision events are saved in the _collisionList vector in a fixed hirarchy: a collision is defined by the world entities
+ *  that collide. For each collision there is an entry in _collisionList. Each collision itself again contains collision events which are
+ *  defined as collisions between the boundibg volumes (BV) of the world entities. This could look like this:
+ *
+ *  - Collision (WorldEntity_i  <=> WorldEntity_j)
+ *     +- CollisionEvent( some BV <=> some other BV)
+ *     +- CollisionEvent( some BV <=> some other BV)
+ *  - Collision (WorldEntity_k <=> WorldEntity_l)
+ *     +- CollisionEvent( some BV <=> some other BV)
+ *     +- CollisionEvent( some BV <=> some other BV)
+ *     +- CollisionEvent( some BV <=> some other BV)
+ *     +- CollisionEvent( some BV <=> some other BV)
+ *  - ... etc ...
+ *
+ *
+ *  When the collisions are processed by the handleCollision() function each collision pair is checked for their reactions (since each
+ *  WorldEntity can define several reactions to a collision). After all the reactions are calculated and applied the collision object is
+ *  put back.
+ */
+
+#ifndef _COLLISION_TUBE_H
+#define _COLLISION_TUBE_H
+
+#include "base_object.h"
+#include "cr_engine.h"
+#include "world_entity.h"
+
+#include "vector.h"
+#include <vector>
+
+class Collision;
+class WorldEntity;
+class BoundingVolume;
+
+namespace CoRe
+{
+
+  class CollisionReaction;
+
+  //! A class containing all CollisionEvents (structured as defined in the file doxygen tags)
+  class CollisionTube : public BaseObject
+  {
+    ObjectListDeclaration(CollisionTube);
+
+    typedef std::vector<Collision*>::iterator     CollisionIterator;
+    typedef std::vector<Collision*>               CollisionVector;
+
+
+    /* Constructor/Deconstructor/Singleton Interface */
+  public:
+    inline static CollisionTube* getInstance() { if( !singletonRef) singletonRef = new CollisionTube(); return singletonRef; }
+
+    virtual ~CollisionTube();
+
+  private:
+    CollisionTube();
+    CollisionTube(const CollisionTube& tube) {}
+
+    static CollisionTube*          singletonRef;                         //!< the singleton instance
+
+
+    /* Collision Handling */
+  public:
+    void registerCollisionEvent(WorldEntity* entityA, WorldEntity* entityB, BoundingVolume* bvA, BoundingVolume* bvB);
+    void registerCollisionEvent(CREngine::CollisionType type, WorldEntity* entity, WorldEntity* groundEntity,
+                                const Vector& normal, const Vector& position, bool bInWall = false);
+    Collision* registerCollision(WorldEntity* entityA, WorldEntity* entityB);
+
+    void reset();
+
+    /** @returns an iterator pointing to the beginning of the list */
+    CollisionIterator begin() { return this->_collisionList.begin(); }
+    /** @returns an iterator pointing to the end of the list */
+    CollisionIterator end()   { return this->_collisionList.end(); }
+
+
+  private:
+    CollisionVector             _collisionList;                      //!< the list of collisions since the last processing
+
+
+    /* Misc State Informations */
+  public:
+    /** @returns true if at least one of both WorldEntities are subscribed for a collision reaction */
+    inline bool isReactive(const WorldEntity& entityA, const WorldEntity& entityB) const
+      { return (entityA.isReactive(entityB) && entityB.isReactive(entityA)); }
+
+  };
+
+}
+
+#endif /* _COLLISION_TUBE_H */
Index: /trunk/src/lib/collision_reaction/cr_defs.h
===================================================================
--- /trunk/src/lib/collision_reaction/cr_defs.h	(revision 10012)
+++ /trunk/src/lib/collision_reaction/cr_defs.h	(revision 10013)
@@ -28,16 +28,4 @@
 
 
-//!< the collision axis x collision event
-#define COLLISION_TYPE_AXIS_X      1
-#define COLLISION_TYPE_AXIS_X_NEG  2
-//!< the collision axis y collision event
-#define COLLISION_TYPE_AXIS_Y      3
-#define COLLISION_TYPE_AXIS_Y_NEG  4
-//!< the collision axis z collision event
-#define COLLISION_TYPE_AXIS_Z      5
-#define COLLISION_TYPE_AXIS_Z_NEG  6
-//!< the collision is a obb collision
-#define COLLISION_TYPE_OBB      8
 
-
-#endif /* _NETWORK_MANAGER */
+#endif /* _CR_DEFS_H */
Index: /trunk/src/lib/collision_reaction/cr_engine.cc
===================================================================
--- /trunk/src/lib/collision_reaction/cr_engine.cc	(revision 10012)
+++ /trunk/src/lib/collision_reaction/cr_engine.cc	(revision 10013)
@@ -17,8 +17,12 @@
 
 
+#include "cr_object_damage.h"
+#include "cr_physics_full_walk.h"
+#include "cr_physics_ground_walk.h"
 
 #include "collision.h"
 #include "collision_event.h"
-#include "collision_handle.h"
+#include "collision_filter.h"
+#include "collision_tube.h"
 #include "cr_defs.h"
 
@@ -27,152 +31,184 @@
 #include "debug.h"
 
-
-
-ObjectListDefinition(CREngine);
-/**
- * standard constructor
- */
-CREngine::CREngine ()
-  : BaseObject()
+namespace CoRe
 {
-  this->registerObject(this, CREngine::_objectList);
-   this->setName("CREngine");
-
-   this->init();
+
+  ObjectListDefinition(CREngine);
+
+
+  /**
+   * standard constructor
+   */
+  CREngine::CREngine ()
+      : BaseObject()
+  {
+    this->registerObject(this, CREngine::_objectList);
+    this->setName("CREngine");
+
+    this->init();
+  }
+
+  /**
+   *  the singleton reference to this class
+   */
+  CREngine* CREngine::singletonRef = NULL;
+
+  /**
+     @brief standard deconstructor
+   */
+  CREngine::~CREngine ()
+  {
+    CREngine::singletonRef = NULL;
+
+    if( this->collisionsUnused.size() != CR_MAX_COLLISIONS)
+      PRINTF(0)("CollisionReaction Error: Collision cache size missmatch: %i of %i\n", this->collisionsUnused.size(), CR_MAX_COLLISIONS);
+    if( this->collisionEventsUnused.size() != CR_MAX_COLLISION_EVENTS)
+      PRINTF(0)("CollisionReaction Error: CollisionEvent cache size missmatch: %i of %i\n", this->collisionEventsUnused.size(), CR_MAX_COLLISION_EVENTS);
+
+    this->reset();
+
+    CollisionIterator it1 = this->collisionsUnused.begin();
+    for(; it1 < this->collisionsUnused.end(); it1++)
+      delete *it1;
+    CollisionEventIterator it2 = this->collisionEventsUnused.begin();
+    for(; it2 < this->collisionEventsUnused.end(); it2++)
+      delete *it2;
+
+    this->collisionsUnused.clear();
+    this->collisionEventsUnused.clear();
+  }
+
+
+  /**
+   * inits the CREngine to a working state
+   */
+  void CREngine::init()
+  {
+    // precaching:
+    // create a list of Collisions and CollisionEvents for fast object recycling purposes
+    for( int i = 0; i < CR_MAX_COLLISIONS; i++)
+      this->collisionsUnused.push_back(new Collision());
+    for( int i = 0; i < CR_MAX_COLLISION_EVENTS; i++)
+      this->collisionEventsUnused.push_back(new CollisionEvent());
+
+
+    // push the collision reaction object on the list in the right order
+
+    // physical reactions
+    this->_reactionList[CREngine::CR_PHYSICS_MOMENTUM]      = NULL;
+    this->_reactionList[CREngine::CR_PHYSICS_STEP_BACK]     = NULL;
+    this->_reactionList[CREngine::CR_PHYSICS_GROUND_WALK]   = new CRPhysicsGroundWalk();
+    this->_reactionList[CREngine::CR_PHYSICS_FULL_WALK]     = new CRPhysicsFullWalk();
+    this->_reactionList[CREngine::CR_PHYSICS_DAMAGE]        = NULL;
+    // object based reactions
+    this->_reactionList[CREngine::CR_OBJECT_DAMAGE]         = new CRObjectDamage();
+    this->_reactionList[CREngine::CR_OBJECT_PICKUP]         = NULL;
+    // misc reactions
+    this->_reactionList[CREngine::CR_VERTEX_TRAFO]          = NULL;
+    this->_reactionList[CREngine::CR_SPECIAL_CALLBACK]      = NULL;
+  }
+
+
+  /**
+   * @returns an instance to a collision object. instead of creating new object this ones can be resycled
+   */
+  Collision* CREngine::popCollisionObject()
+  {
+    if( !this->collisionsUnused.empty())
+    {
+      this->collisionsUsed.push_back(this->collisionsUnused.back());
+      this->collisionsUnused.pop_back();
+      return this->collisionsUsed.back();
+    }
+    else
+    {
+      PRINTF(0)("There is no Collision Object left in the precache table, fatal error will cause segfault, change CR_MAX_COLLISIONS\n");
+      assert(false);
+      return NULL;
+    }
+  }
+
+
+  /**
+   * @return an instanco of a CollisionEvent object. instead of creating a new object this ones can be used and resycled
+   */
+  CollisionEvent* CREngine::popCollisionEventObject()
+  {
+    if( !this->collisionEventsUnused.empty())
+    {
+      this->collisionEventsUsed.push_back(this->collisionEventsUnused.back());
+      this->collisionEventsUnused.pop_back();
+      return this->collisionEventsUsed.back();
+    }
+    else
+    {
+      PRINTF(0)("There is no Collision Object left in the precache table, fatal error will cause segfault, change CR_MAX_COLLISION_EVENTS\n");
+      assert(false);
+      return NULL;
+    }
+  }
+
+
+  /**
+   * handles all collisions in registered in this tube
+   */
+  void CREngine::handleCollisions()
+  {
+    // for all collisions:
+    CollisionIterator ci = CollisionTube::getInstance()->begin();
+    for(; ci < CollisionTube::getInstance()->end(); ci++)
+    {
+      for( int i = CREngine::CR_PHYSICS_MOMENTUM; i < CREngine::CR_NUMBER; i++)
+      {
+        if( _reactionList[i] == NULL)
+          continue;
+
+//         PRINTF(0)("CR CHECK: collision between: %s, %s\n", (*ci)->getEntityA()->getClassName().c_str(), (*ci)->getEntityB()->getClassName().c_str());
+
+        // check if entity A or B is subscibed for this event
+        bool aReact = (*ci)->getEntityA()->isReactive(*(*ci)->getEntityB(), (CREngine::ReactionType)i);
+        bool bReact = (*ci)->getEntityB()->isReactive(*(*ci)->getEntityA(), (CREngine::ReactionType)i);
+
+        // store this information
+        (*ci)->setEntityACollide(aReact);
+        (*ci)->setEntityBCollide(bReact);
+
+        // and execute the reaction
+        if(  aReact || bReact)
+        {
+          this->_reactionList[i]->reactToCollision(*ci);
+          //PRINTF(0)("executing reaction: %s, between %s - %s\n", this->_reactionList[i]->getClassName().c_str(), (*ci)->getEntityA()->getClassName().c_str(), (*ci)->getEntityB()->getClassName().c_str());
+        }
+      }
+      (*ci)->reset();
+    }
+
+    this->reset();
+  }
+
+
+  /**
+   * flushes all the collision lists and puts them to their initial state
+   */
+  void CREngine::reset()
+  {
+    CollisionIterator it1 = this->collisionsUsed.begin();
+    for(; it1 < this->collisionsUsed.end(); it1++)
+      this->collisionsUnused.push_back(*it1);
+
+    CollisionEventIterator it2 = this->collisionEventsUsed.begin();
+    for(; it2 < this->collisionEventsUsed.end(); it2++)
+      this->collisionEventsUnused.push_back(*it2);
+
+    this->collisionsUsed.clear();
+    this->collisionEventsUsed.clear();
+
+    CollisionTube::getInstance()->reset();
+  }
+
+
+  void CREngine::debug()
+  {
+  }
+
 }
-
-/**
- *  the singleton reference to this class
- */
-CREngine* CREngine::singletonRef = NULL;
-
-/**
-   @brief standard deconstructor
- */
-CREngine::~CREngine ()
-{
-  CREngine::singletonRef = NULL;
-
-  if( this->collisionsUnused.size() != CR_MAX_COLLISIONS)
-    PRINTF(0)("CollisionReaction Error: Collision cache size missmatch: %i of %i\n", this->collisionsUnused.size(), CR_MAX_COLLISIONS);
-  if( this->collisionEventsUnused.size() != CR_MAX_COLLISION_EVENTS)
-    PRINTF(0)("CollisionReaction Error: CollisionEvent cache size missmatch: %i of %i\n", this->collisionEventsUnused.size(), CR_MAX_COLLISION_EVENTS);
-
-  this->reset();
-
-  std::vector<Collision*>::iterator it1 = this->collisionsUnused.begin();
-  for(; it1 < this->collisionsUnused.end(); it1++)
-    delete *it1;
-  std::vector<CollisionEvent*>::iterator it2 = this->collisionEventsUnused.begin();
-  for(; it2 < this->collisionEventsUnused.end(); it2++)
-    delete *it2;
-
-  this->collisionsUnused.clear();
-  this->collisionEventsUnused.clear();
-}
-
-/**
- * inits the CREngine to a working state
- */
-void CREngine::init()
-{
-  // create a list of Collision events (precaching)
-  for( int i = 0; i < CR_MAX_COLLISIONS; i++)
-    this->collisionsUnused.push_back(new Collision());
-  for( int i = 0; i < CR_MAX_COLLISION_EVENTS; i++)
-    this->collisionEventsUnused.push_back(new CollisionEvent());
-}
-
-
-/**
- * flushes the CollisionHandles and restores the CREngine to the initial state
- */
-void CREngine::reset()
-{
-  // first clear all CollisionHandles
-
-  std::vector<CollisionHandle*>::iterator it = this->collisionHandles.begin();
-  for(; it < this->collisionHandles.end(); it++)
-  {
-    (*it)->reset();
-    delete *it;
-  }
-
-  this->collisionHandles.clear();
-}
-
-
-/**
- * subscribes a WorldEntity for a CollisionReaction
- *  @param owner: the WE to subscribe
- *  @param type: the type of collision reaction to perform
- *  @return the newly created CollisionHandle
- */
-CollisionHandle* CREngine::subscribeReaction(WorldEntity* owner, CRType type)
-{
-  CollisionHandle* ch = new CollisionHandle(owner, type);
-  this->collisionHandles.push_back(ch);
-
-  return ch;
-}
-
-
-/**
- * unsubscribe reaction from the reaction list
- *  @param collisionHandle the CollisionHandle to remove
- *  @param returns true if worked collrectly
- */
-bool CREngine::unsubscribeReaction(CollisionHandle* collisionHandle)
-{
-  std::vector<CollisionHandle*>::iterator it;
-  for( it = this->collisionHandles.begin(); it != this->collisionHandles.end(); it++)  {
-    if( *it == collisionHandle) {
-      this->collisionHandles.erase(it);
-      delete collisionHandle;
-      return true;
-    }
-  }
-  return false;
-}
-
-
-/**
- * processes the collisions by calling the EventHandlers
- */
-void CREngine::handleCollisions()
-{
-  std::vector<CollisionHandle*>::iterator it;
-  for( it = this->collisionHandles.begin(); it != this->collisionHandles.end(); it++)
-  {
-    if( !(*it)->isDispatched() || (*it)->isContinuousPoll())  //does it have any collisions to report at all
-    {
-      (*it)->handleCollisions();
-    }
-  }
-  this->flushCollisions();
-}
-
-
-/**
- * flushes all the collision lists and puts them to their initial state
- */
-void CREngine::flushCollisions()
-{
-  std::vector<Collision*>::iterator it1 = this->collisionsUsed.begin();
-  for(; it1 < this->collisionsUsed.end(); it1++)
-    this->collisionsUnused.push_back(*it1);
-
-  std::vector<CollisionEvent*>::iterator it2 = this->collisionEventsUsed.begin();
-  for(; it2 < this->collisionEventsUsed.end(); it2++)
-    this->collisionEventsUnused.push_back(*it2);
-
-  this->collisionsUsed.clear();
-  this->collisionEventsUsed.clear();
-}
-
-
-void CREngine::debug()
-{
-
-}
-
Index: /trunk/src/lib/collision_reaction/cr_engine.h
===================================================================
--- /trunk/src/lib/collision_reaction/cr_engine.h	(revision 10012)
+++ /trunk/src/lib/collision_reaction/cr_engine.h	(revision 10013)
@@ -16,79 +16,90 @@
 #include <vector>
 
-// FORWARD DECLARATION
-class CollisionHandle;
-class Collision;
-class CollisionEvent;
 class WorldEntity;
 
-//! A default singleton class.
-class CREngine : public BaseObject
+
+namespace CoRe
 {
-  ObjectListDeclaration(CREngine);
+  class Collision;
+  class CollisionEvent;
+  class CollisionReaction;
+
+
+  //! A default singleton class.
+  class CREngine : public BaseObject
+  {
+    ObjectListDeclaration(CREngine);
+
+    typedef std::vector<CollisionEvent*>             CollisionEventVector;
+    typedef std::vector<Collision*>                  CollisionVector;
+    typedef std::vector<Collision*>::iterator        CollisionIterator;
+    typedef std::vector<CollisionEvent*>::iterator   CollisionEventIterator;
+
 
   public:
-  typedef enum CRType {
-    CR_PHYSICS_MOMENTUM   = 0,    //!< physical reaction: conservervation of momentum
-    CR_PHYSICS_STEP_BACK,         //!< physical reaction: just go to the last position without collisions
-    CR_PHYSICS_GROUND_WALK,       //!< physical reaction: stand on the ground, no movement: simulating simple normal force away from the gravity force
-    CR_PHYSICS_FULL_WALK,         //!< physical reaction: walking on the ground (inkl. hills etc)
-    CR_PHYSICS_DAMAGE,            //!< physical reaction: daling damage according to the object energy and their structural stability
+    typedef enum ReactionType {
+      CR_PHYSICS_MOMENTUM   = 0,           //!< physical reaction: conservervation of momentum
+      CR_PHYSICS_STEP_BACK,                //!< physical reaction: just go to the last position without collisions
+      CR_PHYSICS_GROUND_WALK,              //!< physical reaction: stand on the ground, no movement: simple normal force away from the gravity force
+      CR_PHYSICS_FULL_WALK,                //!< physical reaction: walking on the ground (inkl. hills etc)
+      CR_PHYSICS_DAMAGE,                   //!< physical reaction: daling damage according to the object energy and their structural stability
 
-    CR_OBJECT_DAMAGE,             //!< object raction: deals damage according to the objects specific damage potential (like weapons, nukes, etc.)
-    CR_OBJECT_PICKUP,             //!< object rection: calling the objects pickup functions, let them handle the collision (once!)
+      CR_OBJECT_DAMAGE,                    //!< object raction: deals damage according to the objects specific damage potential (like weapons, nukes, etc.)
+      CR_OBJECT_PICKUP,                    //!< object rection: calling the objects pickup functions, let them handle the collision (once!)
 
-    CR_VERTEX_TRAFO,              //!< vertex trafo: transforming the vertex according to the damage
+      CR_VERTEX_TRAFO,                     //!< vertex trafo: transforming the vertex according to the damage
 
-    CR_SPECIAL_CALLBACK,          //!< special: call a callback function
+      CR_SPECIAL_CALLBACK,                 //!< special: call a callback function
 
-    CR_NUMBER
+      CR_NUMBER
+    };
+
+    typedef enum CollisionType {
+      CR_COLLISION_TYPE_AXIS_X       = 0,  //!< collision on x axis
+      CR_COLLISION_TYPE_AXIS_X_NEG,        //!< collision on negative x axis
+      CR_COLLISION_TYPE_AXIS_Y,            //!< collision on y axis
+      CR_COLLISION_TYPE_AXIS_Y_NEG,        //!< collision on negative y axis
+      CR_COLLISION_TYPE_AXIS_Z,            //!< collision on z axis
+      CR_COLLISION_TYPE_AXIS_Z_NEG,        //!< collision on negative z axis
+      CR_COLLISION_TYPE_OBB,               //!< object aligned bounding box collide
+
+      CR_COLLISION_TYPE_NUMBER
+    };
+
+
+    virtual ~CREngine(void);
+
+    /** @returns a Pointer to the only object of this Class */
+    inline static CREngine* getInstance() { if (!singletonRef) singletonRef = new CREngine();  return singletonRef; };
+
+    Collision* popCollisionObject();
+    CollisionEvent* popCollisionEventObject();
+
+    void handleCollisions();
+
+    void debug();
+
+
+  private:
+    CREngine();
+    void init();
+
+    void reset();
+
+
+  private:
+    static CREngine*                    singletonRef;             //!< the reference to the CREngine object (singleton)
+
+    CollisionVector                     collisionsUsed;           //!< a list of used, cached collisions
+    CollisionVector                     collisionsUnused;         //!< a list of unused, cached collisions
+
+    CollisionEventVector                collisionEventsUsed;      //!< a list of used, cached collision events
+    CollisionEventVector                collisionEventsUnused;    //!< a list of unused, cached collision events
+
+    CollisionReaction*                  _reactionList[CREngine::CR_NUMBER];  //!< the collision reaction list containing all reactions types
+
+
   };
 
-  virtual ~CREngine(void);
-
-  /** @returns a Pointer to the only object of this Class */
-  inline static CREngine* getInstance() { if (!singletonRef) singletonRef = new CREngine();  return singletonRef; };
-
-  void reset();
-
-
-  CollisionHandle* subscribeReaction(WorldEntity* worldEntity, CRType type);
-
-  bool unsubscribeReaction(CollisionHandle* collisionHandle);
-
-  void handleCollisions();
-
-  /** @returns an instance to a collision object. instead of creating new object this ones can be resycled */
-  inline Collision* popCollisionObject() {
-    if( !this->collisionsUnused.empty()) {
-      this->collisionsUsed.push_back(this->collisionsUnused.back()); this->collisionsUnused.pop_back(); return this->collisionsUsed.back(); } else return NULL; }
-
-
-  /** @return an instanco of a CollisionEvent object. instead of creating a new object this ones can be used and resycled */
-  inline CollisionEvent* popCollisionEventObject() {
-    if( !this->collisionEventsUnused.empty()) {
-      this->collisionEventsUsed.push_back(this->collisionEventsUnused.back()); this->collisionEventsUnused.pop_back(); return this->collisionEventsUsed.back(); } else return NULL; }
-
-  void debug();
-
-
-private:
-  CREngine();
-  void init();
-
-  void flushCollisions();
-
-
-private:
-  std::vector<CollisionHandle*>       collisionHandles;         //!< list with the collision handles
-
-  std::vector<Collision*>             collisionsUsed;           //!< a list of used, cached collisions
-  std::vector<Collision*>             collisionsUnused;         //!< a list of unused, cached collisions
-
-  std::vector<CollisionEvent*>        collisionEventsUsed;      //!< a list of used, cached collision events
-  std::vector<CollisionEvent*>        collisionEventsUnused;    //!< a list of unused, cached collision events
-
-  static CREngine*                    singletonRef;             //!< the reference to the CREngine object (singleton)
-};
-
+}
 #endif /* _CR_ENGINE_ */
Index: /trunk/src/lib/collision_reaction/cr_object_damage.cc
===================================================================
--- /trunk/src/lib/collision_reaction/cr_object_damage.cc	(revision 10012)
+++ /trunk/src/lib/collision_reaction/cr_object_damage.cc	(revision 10013)
@@ -26,61 +26,61 @@
 #include "debug.h"
 
+namespace CoRe
+{
+
+  ObjectListDefinition(CRObjectDamage);
+  /**
+   *  standard constructor
+   */
+  CRObjectDamage::CRObjectDamage ()
+      : CollisionReaction()
+  {
+    this->registerObject(this, CRObjectDamage::_objectList);
+  }
 
 
-ObjectListDefinition(CRObjectDamage);
-/**
- *  standard constructor
- */
-CRObjectDamage::CRObjectDamage ()
-  : CollisionReaction()
-{
-  this->registerObject(this, CRObjectDamage::_objectList);
-}
+  /**
+   *  standard deconstructor
+   */
+  CRObjectDamage::~CRObjectDamage ()
+  {}
 
 
-/**
- *  standard deconstructor
- */
-CRObjectDamage::~CRObjectDamage ()
-{
-}
+  /**
+   * caluculates and applys the reaction to a specific collision
+   *  @param collision the collision
+   */
+  void CRObjectDamage::reactToCollision(Collision* collision)
+  {
+    float damage = 0.0f;
 
+    PRINTF(0)("Dealing damage - Handling collision: %s vs %s\n",
+              collision->getEntityA()->getClassCName(),
+              collision->getEntityB()->getClassCName());
 
-/**
- * caluculates and applys the reaction to a specific collision
- *  @param collision the collision
- */
-void CRObjectDamage::reactToCollision(Collision* collision)
-{
-  float damage = 0.0f;
+    // the collision damage been dealed by the entity
+    if( collision->isEntityACollide())
+    {
+      damage = collision->getEntityB()->getDamage();
+      collision->getEntityA()->hit(damage, collision->getEntityB());
+      PRINTF(0)("Dealing damage - %f damage to %s \n", damage, collision->getEntityA()->getClassCName());
+    }
 
-  PRINTF(4)("Dealing damage - Handling collision: %s vs %s\n",
-            collision->getEntityA()->getClassCName(),
-            collision->getEntityB()->getClassCName());
+    if( collision->isEntityBCollide())
+    {
+      damage = collision->getEntityA()->getDamage();
+      collision->getEntityB()->hit(damage, collision->getEntityA());
+      PRINTF(0)("Dealing damage - %f damage to %s \n", damage, collision->getEntityB()->getClassCName());
+    }
 
-  // the collision damage been dealed by the entity
-  if( collision->isEntityACollide()) {
-    damage = collision->getEntityB()->getDamage();
-    collision->getEntityA()->hit(damage, collision->getEntityB());
-    PRINTF(4)("Dealing damage - %f damage to %s \n", damage, collision->getEntityA()->getClassCName());
+    //   const std::vector<CollisionEvent*>* collisionEvents = &(collision->getCollisionEvents());
+    //   std::vector<CollisionEvent*>::const_iterator it = collisionEvents->begin();
+    //   for(; it != collisionEvents->end(); it++)
+    //   {
+    //     // go through the collisions and try to estimate the damage
+    //     mass = (*it)->getEntityA()->getMass();
+    //   }
+
   }
 
-  if( collision->isEntityBCollide()) {
-    damage = collision->getEntityA()->getDamage();
-    collision->getEntityB()->hit(damage, collision->getEntityA());
-    PRINTF(4)("Dealing damage - %f damage to %s \n", damage, collision->getEntityB()->getClassCName());
-  }
-
-  collision->flushCollisionEvents();
-  collision->dispatched();
-
-//   const std::vector<CollisionEvent*>* collisionEvents = &(collision->getCollisionEvents());
-//   std::vector<CollisionEvent*>::const_iterator it = collisionEvents->begin();
-//   for(; it != collisionEvents->end(); it++)
-//   {
-//     // go through the collisions and try to estimate the damage
-//     mass = (*it)->getEntityA()->getMass();
-//   }
-
 }
-
Index: /trunk/src/lib/collision_reaction/cr_object_damage.h
===================================================================
--- /trunk/src/lib/collision_reaction/cr_object_damage.h	(revision 10012)
+++ /trunk/src/lib/collision_reaction/cr_object_damage.h	(revision 10013)
@@ -7,13 +7,17 @@
 #define _CR_OBJECT_DAMAGE_H
 
+
 #include "collision_reaction.h"
 
 
-class Collision;
+namespace CoRe
+{
 
-//! A class representing a reaction to a collision: dealing damage to an object
-class CRObjectDamage : public CollisionReaction
-{
-  ObjectListDeclaration(CRObjectDamage);
+  class Collision;
+
+  //! A class representing a reaction to a collision: dealing damage to an object
+  class CRObjectDamage : public CollisionReaction
+  {
+    ObjectListDeclaration(CRObjectDamage);
   public:
     CRObjectDamage();
@@ -22,7 +26,6 @@
     virtual void reactToCollision(Collision* collision);
 
-  private:
-
-};
+  };
+}
 
 #endif /* _CR_OBJECT_DAMAGE_H */
